<?php

/**
 * Fichier contrôleur de gestion des agendas
 */

session_start();

require_once('classes/Agenda.php');
require_once('classes/Association_Agenda.php');

switch($_GET['action']) {
case "creer" :
    creerAgenda();
    break;

case "ajouter_public":
    ajouterPublic();
    break;

case "partager" :
    partagerAgenda();
    break;

case "consulter" :
    consulterAgenda();
    break;

case "modifier" :
    modifierAgenda();
    break;

case "supprimer" :
    supprimerAgenda();
    break;

case "accueil" :
    accueil();
    break;

default:
    accueil();
    break;
}

/*
 * OPÉRATION S3
 * Ajouter un nouvel agenda dans le système
 */
function creerAgenda(){
    require_once 'identification.php';
    if(!empty($_POST['nom']) && isset($_POST['est_public'])) {
        $nom = $_POST['nom'];
        $desc = $_POST['desc'];
        $est_public = $_POST['est_public'];
        $couleur = $_POST['couleur'];
        $afficher = $_POST['afficher'];

        $agenda = new Agenda(array(
            'nom' => $nom,
            'descr' => $desc,
            'est_public' => $est_public,
            'couleur' => $couleur,
            'afficher' => $afficher
        ), true);

        $agenda->save();

        $association_agenda = new Association_Agenda(array(
            'login' => $_SESSION['login'],
            'id' => $agenda->id
        ), true);

        $association_agenda->save();

        require_once 'vues/VueSuccesCreerAgenda.php';
        new VueSuccesCreerAgenda();
    } else {

        $agendas_publics = Agenda::findAllPublic();

        require_once 'vues/VueFormCreerAgenda.php';
        new VueFormCreerAgenda($agendas_publics);

        return false;
    }
    return true;
}

function ajouterPublic() {
    require_once 'identification.php';
    echo $_POST['id_public'];
    if( !empty($_POST['id_public'])) {
        $id = $_POST['id_public'];

        require_once 'classes/Partage.php';

        $partage = new Partage(array(
            'login' => $_SESSION['login'],
            'id_agenda' => $id,
            'droit' => 4
        ), true);

        $partage->save();
        require_once 'vues/VueSuccesCreerAgenda.php';
        new VueSuccesCreerAgenda();
    
    } else {

        $agendas_publics = Agenda::findAllPublic();

        require_once 'vues/VueFormCreerAgenda.php';
        new VueFormCreerAgenda($agendas_publics);

    }
}


/*
 * OPÉRATION S5
 * Partager un agenda avec un utilisateur du système
 */

function partagerAgenda() {
    require_once 'identification.php';

    if( !empty($_POST['id']) && !empty($_POST['login_partage'])) {
        $id = $_POST['id'];
        
        $droit = 0;
        if( !empty($_POST['partager']))
            $droit += $_POST['partager'];
        if( !empty($_POST['consulter']))
            $droit += $_POST['consulter'];
        if( !empty($_POST['modifier']))
            $droit += $_POST['modifier'];

        $login_partage = $_POST['login_partage'];

        require_once 'classes/Utilisateur.php';
        require_once 'classes/Partage.php';

        if(Utilisateur::existe($login_partage)) {
            $agenda = Agenda::findById(array("id" => $id));
            $droitsUtil = $agenda->droitsUtilisateur($_SESSION['login']);
            if($droitsUtil == 7 || $droitsUtil == 5) {
                $partage = new Partage(array(
                    'login' => $login_partage,
                    'id_agenda' => $id,
                    'droit' => $droit),
                true);
                $partage->save();

                // envoyer un mail de notification
                $sujet = "Partage sur Ajuda";
                $message = "Bonjour,\n\nL'utilisateur " . $_SESSION['login'] . " vous a partagé un agenda.\n";
                $message .= "Accédez à http://neptune.esial.uhp-nancy.fr/~vaubo0051/agenda.php?action=consulter&id=" . $id . " pour le consulter.\n\n";
                $message .= "L'équipe Ajuda.";
                $headers = "From: Ajuda <webmaster@ajuda.cesi>" . "\r\n";
                $headers.= "Reply-To: webmaster@ajuda.cesi";
                mail($login_partage, $sujet, $message, $headers);



                require_once 'vues/VueSuccesPartagerAgenda.php';
                new VueSuccesPartagerAgenda();
            } else {
                require_once 'vues/VueErreurDroits.php';
                new VueErreurDroits();
            }
        } else {
            require_once 'vues/VueErreurUtilisateurInexistant.php';
            new VueErreurUtilisateurInexistant();
        }

    } else {

        if( !empty($_GET['id'])) {

            $agenda = Agenda::findById(array("id" => $_GET['id']));
            $droitsUtil = $agenda->droitsUtilisateur($_SESSION['login']);
            if($droitsUtil == 7 || $droitsUtil == 5) {

                require_once 'vues/VueFormPartagerAgenda.php';
                new VueFormPartagerAgenda($_GET['id']);
            } else {
                require_once 'vues/VueErreurDroits.php';
                new VueErreurDroits();

            }
        } else {
            require_once 'vues/VueErreurAgendaID.php';
            new VueErreurAgendaID();
        }
    }
}

/*
 * OPÉRATION S7
 * Consulter la liste des évènements d'un agenda
 */
function consulterAgenda() {
    if(!empty($_REQUEST['id'])) {
	$id = $_REQUEST['id'];
	$agenda = Agenda::findById(array("id" => $id));
	if(!empty($agenda)) {
	    if($agenda->est_public || !empty($_SESSION['login']) && $agenda->droitsUtilisateur($_SESSION['login']) >= 4) {
		require_once 'vues/VueConsulterAgenda.php';

		new VueConsulterAgenda(
		    $agenda,
		    !empty($_GET['mois']) ? $_GET['mois'] : null,
		    !empty($_GET['annee']) ? $_GET['annee'] : null
		);

	    } else {
		require_once 'vues/VueErreurDroits.php';
		new VueErreurDroits();
	    }
	} else {
	    require_once 'vues/VueErreurAgendaID.php';
	    new VueErreurAgendaID();
	}
    } else {
	require_once 'vues/VueErreurAgendaID.php';
	new VueErreurAgendaID();
    }
}

/*
 * OPÉRATIONS DE GESTION, non comprises dans la descr lexicale
 */
function modifierAgenda() {
    require_once 'identification.php';

    if(!empty($_POST['id']) && !empty($_POST['nom']) && isset($_POST['est_public'])) {

        $id = $_POST['id'];
        $nom = $_POST['nom'];
        $desc = $_POST['desc'];
        $est_public = $_POST['est_public'];
        $couleur = $_POST['couleur'];
        $afficher = $_POST['afficher'];

        $agenda = Agenda::findById(array('id' => $id));

        $agenda->nom = $nom;
        $agenda->descr = $desc;
        $agenda->est_public = $est_public;
        $agenda->couleur = $couleur;
        $agenda->afficher = $afficher;

        $agenda->save();

        require_once 'vues/VueSuccesModifAgenda.php';
        new VueSuccesModifAgenda();

    } elseif(!empty($_POST['id'])) {
        require_once 'vues/VueErreurModifAgenda.php';
        new VueErreurModifAgenda();

    } elseif(!empty($_GET['id'])) {
        $id = $_GET['id'];
        $agenda = Agenda::findById(array("id" => $id));

        if(isset($agenda)) {
            if($agenda->droitsUtilisateur($_SESSION['login']) > 5) {
                require_once 'vues/VueFormModifierAgenda.php';
                new VueFormModifierAgenda($agenda);
            } else {
                require_once 'vues/VueErreurDroits.php';
                new VueErreurDroits();
            }
        } else {
            require_once 'vues/VueErreurAgendaID.php';
            new VueErreurAgendaID();
        }

    } else {
        require_once 'vues/VueErreurAgendaID.php';
        new VueErreurAgendaID();
    }
}

function supprimerAgenda() {
    require_once 'identification.php';

    if(!empty($_GET['id'])) {
        $a = Agenda::findById(array("id" => $_GET['id']));

        if(!empty($a)) {
            $droits = $a->droitsUtilisateur($_SESSION['login']);
            if($droits == 7) {
                $a = Agenda::findById(array("id" => $_GET['id']));
                $a->delete();

                require_once 'vues/VueSuccesSupAgenda.php';
                new VueSuccesSupAgenda();

            } else {
                require_once 'classes/Partage.php';
                $partages = Partage::findByAgenda($a->id);
                foreach($partages as $p) {
                    $p->delete();
                }
                require_once 'vues/VueSuccesSupAgenda.php';
                new VueSuccesSupAgenda();

            }
        } else {
            require_once 'vues/VueErreurAgendaID.php';
            new VueErreurAgendaID();
        }
    } else {
        require_once 'vues/VueErreurAgendaID.php';
	new VueErreurAgendaID();
    }
}

function accueil() {
    require_once 'classes/Agenda.php';
    require_once 'vues/VueAccueil.php';

    if(!empty($_SESSION['login'])) {
	new VueAccueil(
	    Agenda::findAllProprio(),
	    Agenda::findAllPartage(),
	    !empty($_GET['mois']) ? $_GET['mois'] : null,
	    !empty($_GET['annee']) ? $_GET['annee'] : null
	);
    } else {
	require_once 'vues/VueErreurAccueil.php';
	new VueErreurAccueil();
    }
}

?>
