<?php

require_once 'classes/Base.php';
require_once 'classes/ActiveRecord.php';

class Agenda extends ActiveRecord {
	public function __construct($attrs, $nouveau = false) {
		parent::__construct(
			// Attributs
			array(
				'id',
				'nom',
				'descr',
				'est_public',
				'couleur',
				'afficher'
			),

			// Attributs de clef
			array('id'),

			// Valeurs
			$attrs, $nouveau
		);
	}
	
	/**
	 * Teste si l'utilisateur a accès à l'agenda
	 * @param unknown_type $login
	 */
	public function droitsUtilisateur($login=null) {
		if(is_null($login))
			return $this->est_public ? 4 : 0;

		require_once 'classes/Association_Agenda.php';
		$asso_util_agenda = Association_Agenda::findById(array("login" => $login, "id" => $this->id));
		// tester si l'agenda appartient à l'utilisateur
		if(!empty($asso_util_agenda))
			return 7;
		else {
			// tester si l'agenda est partagé à l'utilisateur
			require_once 'classes/Partage.php';
			$partage = Partage::findById(array("login" => $login, "id_agenda" => $this->id));

			if(!empty($partage))
				return $partage->droit;
            else
                return 0;
		}
	}

	public function insert() {
		parent::insert();
		$this->id = parent::lastInsertId();
	}

	public function delete() {
		parent::delete();

		require_once 'classes/Evenement.php';
		require_once 'classes/Association_Agenda.php';

		$evts = Evenement::findByAgenda($this->id);

		foreach($evts AS $evt)
			$evt->delete();

		$aas = Association_Agenda::findByAgenda($this->id);

		foreach($aas AS $aa)
			$aa->delete();
	}

	public static function findAllPartage() {
		$select_query = "SELECT * FROM agenda a, partage p WHERE a.id=p.id_agenda AND login='{$_SESSION['login']}'";

		$conn = Base::getConnection();
		$query = $conn->prepare($select_query);
		$count = $query->execute();
		
		$values = array();

		while($result = $query->fetch(PDO::FETCH_ASSOC)) {
			$v = new Agenda($result, false);
			$values[] = $v;
		}

		return $values;
	}

	public static function findAllProprio() {
		$select_query = "SELECT * FROM agenda a, association_agenda aa WHERE a.id=aa.id AND login='{$_SESSION['login']}'";

		$conn = Base::getConnection();
		$query = $conn->prepare($select_query);
		$count = $query->execute();
		
		$values = array();

		while($result = $query->fetch(PDO::FETCH_ASSOC)) {
			$values[] = new Agenda($result, false);
		}

		return $values;
	}

    public static function findAllPublic() {
        $select_query = "SELECT * FROM agenda WHERE est_public = 1";

        $conn = Base::getConnection();
        $query = $conn->prepare($select_query);
        $query->execute();

        $values = array();

        while($result = $query->fetch(PDO::FETCH_ASSOC)) {
            $values[] = new Agenda($result, false);
        }

        return $values;
    }
}

?>
