<?php

/** 
 * Classe de connexion à la bdd
 * Pattern Singleton
 */

class Base {
	private static $connection;
	
	public static function getConnection(){
		if(self::$connection == null){
			Base::connect();
		}
		return self::$connection;
	}
	
	public static function connect(){
		include 'classes/config.php';

		date_default_timezone_set('Europe/Paris');

		try {

		    if(SGBD == "mysql")
			self::$connection= new PDO('mysql:dbname=' . $service, $user, $password);
                    else
			self::$connection = new PDO('oci:dbname=' . $PARAM_tns, $PARAM_user, $PARAM_passwd);

		} catch(PDOException $e) {
			die($e->getCode() . $e->getMessage() . "\n" . $e->getTraceAsString());
		}
	}

	public static function cleanUp() {
		self::connect();

		self::$connection->exec('DELETE FROM agenda');
		self::$connection->exec('DELETE FROM evenement');
		self::$connection->exec('DELETE FROM ressource');
		self::$connection->exec('DELETE FROM association_agenda');
		self::$connection->exec('DELETE FROM utilisateur');
		self::$connection->exec('DELETE FROM partage');
		self::$connection->exec('DELETE FROM invitation');
		self::$connection->exec('DELETE FROM association_ressource');
	}
}

?>
