<?php

require_once 'classes/Base.php';
require_once 'classes/ActiveRecord.php';

class Ressource extends ActiveRecord {
	public function __construct($attrs, $nouveau = false) {
		parent::__construct(
			// Attributs
			array(
				'id',
				'nom',
				'descr'
			),

			// Attributs de clef
			array('id'),

			// Valeurs
			$attrs, $nouveau
		);
	}

	public function insert() {
		parent::insert();
		$this->id = parent::lastInsertId();
	}

	public function delete() {
		parent::delete();
		
		require_once 'classes/Association_Ressource.php';
		
		$assos_ress = Association_Ressource::findByRessource($this->id);
		foreach($assos_ress as $ar) {
			$ar->delete();
		}
	}

	public static function findByEvenement($id_evt) {
	    require_once 'classes/Association_Ressource.php';

	    $ress = array();
	    $assos_e_r = Association_Ressource::findByEvenement($id_evt);
	    foreach($assos_e_r as $asso_e_r) {
            $ress[]= Ressource::findById(array('id' => $asso_e_r->id_ressource));
	    }
	    return $ress;
	}
	
}

?>
