<?php

/**
 * Fichier contrôleur de gestion des comptes utilisateurs
 */
session_start();
require_once 'classes/Utilisateur.php';

switch($_GET['action']) {
case "creer" :
    creerCompte();
    break;

case "connexion" :
    connexion();
    break;

case "modifier" :
    modifierCompte();
    break;

case "supprimer" :
    suppressionCompte();
    break;

case "deconnexion" :
    deconnexion();
    break;
}

/*
 * OPÉRATION S1
 * Créer un compte utilisateur dans le système
 */
function creerCompte() {
    if(!empty($_POST['login']) && !empty($_POST['password1'])  && !empty($_POST['password2'])) {

	$login = $_POST['login'];
	$password1 = $_POST['password1'];
	$password2 = $_POST['password2'];
	$prenom = $_POST['prenom'];
	$nom = $_POST['nom'];

	if(Utilisateur::existe($login)) {
	    $creationPossible = false;

	    require_once 'vues/VueErreurCreerCompteUtilisateurExistant.php';
	    new VueErreurCreerCompteUtilisateurExistant();

	} elseif(! preg_match("/^[^@]*@[^@]*\.[^@]*$/", $_POST['login'])) {
	    require_once 'vues/VueErreurCreerCompteMail.php';
	    new VueErreurCreerCompteMail();

	} elseif($_POST['password1'] != $_POST['password2']) {
	    $creationPossible = false;

	    require_once 'vues/VueErreurCreerComptePass.php';
	    new VueErreurCreerComptePass();

	} else {
	    // insérer utilisateur dans la base
	    $u = new Utilisateur(array(
		'login' => $login,
		'password' => md5($password1),
		'nom' => $nom,
		'prenom' => $prenom
	    ), true);

	    $u->save();

	    // envoyer un mail de confirmation
	    $sujet = "Bienvenue sur Ajuda !";
	    $message = "Bonjour,\n\nVotre inscription sur Ajuda est finalisée.\n";
	    $message .= "Accédez à http://neptune.esial.uhp-nancy.fr/~vaubo0051/ pour gérer vos agendas.\n\n";
	    $message .= "L'équipe Ajuda.";
	    $headers = "From: Ajuda <webmaster@ajuda.cesi>" . "\r\n";
	    $headers.= "Reply-To: webmaster@ajuda.cesi";
	    mail($login, $sujet, $message, $headers);

	    $creationPossible = true;

	    $_SESSION['login'] = $login;
	    $_SESSION['password'] = md5($password1);

	    // Créer un nouvel agenda pour le nouvel utilisateur
	    require_once 'classes/Agenda.php';
	    require_once 'classes/Association_Agenda.php';

	    $nom = "Agenda de " . $login;
	    $desc = "Agenda de " . $login;
	    $est_public = 0;
	    $couleur = "000000";
	    $afficher = 1;

	    $agenda = new Agenda(array(
		'nom' => $nom,
		'descr' => $desc,
		'est_public' => $est_public,
		'couleur' => $couleur,
		'afficher' => $afficher
	    ), true);

	    $agenda->save();

	    $association_agenda = new Association_Agenda(array(
		'login' => $_SESSION['login'],
		'id' => $agenda->id
	    ), true);

	    $association_agenda->save();


	    require_once 'vues/VueSuccesCreerCompte.php';
	    new VueSuccesCreerCompte();
	}
    } else {
	$creationPossible = false;

	require_once 'vues/VueFormCreerCompte.php';
	new VueFormCreerCompte();
    }
    return $creationPossible;
}

/*
 * OPÉRATION S2
 */
function connexion() {
    if(isset($_POST['login']) && isset($_POST['password']) && $_POST['login'] != "" && $_POST['password'] != "") {

	$login = $_POST['login'];
	$password = md5($_POST['password']);

	if(Utilisateur::findById(array("login" => $login, "password" => $password))) {
	    $_SESSION['login'] = $login;
	    $_SESSION['password'] = $password;
	    $connecte = true;

	    require_once 'vues/VueSuccesConnexion.php';
	    new VueSuccesConnexion();
	} else {
	    $connecte = false;

	    require_once 'vues/VueErreurConnexion.php';
	    new VueErreurConnexion();
	}
    } else {
	$connecte = false;

	require_once 'vues/VueFormConnexion.php';
	new VueFormConnexion();
    }
    return $connecte;
}

/*
 * OPÉRATIONS DE GESTION, non comprises dans la descr lexicale
 */

function modifierCompte() {
    require_once 'identification.php';

    if( ( !empty($_POST['password1']) && !empty($_POST['password2'] )) || !empty($_POST['nom']) || !empty($_POST['prenom'])) {

	$prenom = $_POST['prenom'];
	$nom = $_POST['nom'];

	$u = Utilisateur::findById(array("login" => $_SESSION['login'], "password" => $_SESSION['password']));
	if(!is_null($u)) {
	    $u->nom = $nom;
	    $u->prenom = $prenom;
	    if( !empty($_POST['password1']) && !empty($_POST['password2'])) {
		if($_POST['password1'] != $_POST['password2']) {

		    require_once 'vues/VueErreurCreerComptePass.php';
		    new VueErreurCreerComptePass();
		    return;
		} else {
		    $password = md5($_POST['password1']);
		    $u->password = $password;

		    $_SESSION['password'] = $password;
		}
	    }

	    $u->save();

	    require_once 'vues/VueSuccesModifCompte.php';
	    new VueSuccesModifCompte();

	}
    } else {
	$utilisateur = Utilisateur::findById(array('login' => $_SESSION['login'], 'password' => $_SESSION['password']));
	require_once 'vues/VueFormModifierCompte.php';
	new VueFormModifierCompte($utilisateur);
    }
}

function suppressionCompte() {
    require_once 'identification.php';
    $u = Utilisateur::findById(array("login" => $_SESSION['login'], "password" => $_SESSION['password']));
    $u->delete();
    deconnexion(true);

    require_once 'vues/VueSuccesSupCompte.php';
    new VueSuccesSupCompte();
}

function deconnexion($fromSuppression=false) {
    if(isset($_SESSION['login']) && isset($_SESSION['password'])) {
	session_destroy();

	if(!$fromSuppression) {
	    require_once 'vues/VueSuccesDeconnexion.php';
	    new VueSuccesDeconnexion();
	}
    }
}

?>
