<?php

require_once 'classes/Base.php';
require_once 'classes/Evenement.php';
require_once 'classes/Agenda.php';

@session_start();

$select_query = array();
$tokens = array();
$evts = array();
$id = array();

if(empty($_POST['id_agenda'])) {
	foreach(array_merge(Agenda::findAllProprio(), Agenda::findAllPartage()) as $agenda)
		$id[] = $agenda->id;
} else {
	$id[] = intval($_POST['id_agenda']);
}

if(isset($_POST['c_periode'])) {
	$select_query[] = 'date_deb <= :datefin AND date_fin >= :datedeb';
	$tokens[':datedeb'] = strtotime($_POST['date_deb']);
	$tokens[':datefin'] = strtotime($_POST['date_fin']);
}

if(isset($_POST['c_lieu'])) {
	$select_query[] = 'lieu LIKE :lieu';
	$tokens['lieu'] = '%'.$_POST['lieu'].'%';
}

if(isset($_POST['c_participant'])) {
	$select_query .= 'EXISTS(SELECT * FROM invitation WHERE login=:participant)';
	$tokens['participant'] = $_POST['participant'];
}

if(isset($_POST['c_nom'])) {
	$select_query[] = 'nom LIKE :nom';
	$tokens['nom'] = '%'.$_POST['nom'].'%';
}

if(isset($_POST['c_descr'])) {
	$select_query[] = 'descr LIKE :descr';
	$tokens['descr'] = '%'.$_POST['descr'].'%';
}

$select_query = 'SELECT * FROM evenement WHERE (id_agenda='.implode(' OR id_agenda=', $id).') AND '.implode(' AND ', $select_query);

$conn = Base::getConnection();
$query = $conn->prepare($select_query);
$query->execute($tokens);

while($result = $query->fetch(PDO::FETCH_ASSOC))
	$evts[] = new Evenement($result, false);

require_once 'vues/VueConsulterRecherche.php';
new VueConsulterRecherche($evts);

?>
