<?php

/**
 * Fichier contrôleur de gestion des ressources
 */
session_start();
require_once 'classes/Ressource.php';

switch($_GET['action']) {
	case "creer" :
		creerRessource();
		break;

	case "associer" :
		ajouterAssociationEvenement();
		break;

	case "consulter" :
		consulterRessource();
		break;

	case "modifier" :
		modifierRessource();
		break;

	case "supprimer" :
		supprimerRessource();
		break;
}

/*
 * OPÉRATION S8
* Créer une ressource dans le système
*/
function creerRessource(){
	require_once 'identification.php';
	if(!empty($_POST['nom'])) {
		$nom = $_POST['nom'];
		$descr = $_POST['descr'];

		$ressource = new Ressource(array(
			'nom' => $nom,
			'descr' => $descr),
		true);

		$ressource->id = $ressource->save();

		require_once 'vues/VueSuccesCreerRessource.php';
		new VueSuccesCreerRessource();
	} else {
		require_once 'vues/VueFormCreerRessource.php';
		new VueFormCreerRessource();

		return false;
	}
	return true;
}

/*
 * OPÉRATION S10
* Ajouter une association entre un événement et une ressource dans le système
* Fonction inutile : association effectuée dans creerEvenement()
*/
function ajouterAssociationEvenement() {
	require_once 'identification.php';
	$id_ressource = $_POST['id_ressource'];
	$id_evt = $_POST['id_evt'];
	if(!empty($id_ressource) && !empty($id_evt)) {
		require_once 'classes/Evenement.php';
		require_once 'classes/Association_Ressource.php';
		$evt = Evenement::findById(array('id' => $id_evt));
		if(! is_null($evt)) {
			$asso_ressource = new Association_Ressource(array(
				'id_ressource' => $id_ressource,
				'id_evenement' => $id_evt),
			true);
			$asso_ressource->save();
			
			require_once 'vues/VueSuccesCreerAssociationEvenementRessource.php';
			new VueSuccesCreerAssociationEvenementRessource();
		} else {
			require_once 'vues/VueErreurEvenementID.php';
			new VueErreurEvenementID();
		}
	} else {
		require_once 'vues/VueFormAssociationEvenementRessource.php';
		new VueFormAssociationEvenementRessource();
	}
}

/*
 * OPÉRATION S14
* Consulter les détails d'une ressource
*/
function consulterRessource() {
	if(!empty($_REQUEST['id'])) {
		$id = $_REQUEST['id'];
		$ress = Ressource::findById(array('id' => $id));
		if(!is_null($ress)) {
			require_once 'vues/VueConsulterRessource.php';
				
			new VueConsulterRessource($ress);
		} else {
			require_once 'vues/VueErreurRessourceID.php';
			new VueErreurRessourceID();
		}
	}
}

/*
 * OPÉRATIONS DE GESTION, non comprises dans la descr lexicale
*/

function modifierRessource() {
	require_once 'identification.php';
	if(!empty($_POST['id']) && !empty($_POST['nom'])) {
		$id = $_POST['id'];
		$nom = $_POST['nom'];
		$descr = $_POST['descr'];

		$ress = Ressource::findById(array('id' => $id));
		if(!is_null($ress)) {
		$ress->nom = $nom;
		$ress->descr = $descr;
		$ress->save();
		
		require_once 'vues/VueSuccesModifRessource.php';
		new VueSuccesModifRessource();
		} else{
			require_once 'vues/VueErreurRessourceID.php';
			new VueErreurRessourceID();
		}
	} else {
		if((! empty($_REQUEST['id']))) {
			$ressource = Ressource::findById(array('id' => $_REQUEST['id']));
			require_once 'vues/VueFormModifierRessource.php';
			new VueFormModifierRessource($ressource);
		} else{
			require_once 'vues/VueErreurRessourceID.php';
			new VueErreurRessourceID();
		}
	}
	
}

function supprimerRessource() {
    require_once 'identification.php';
    if(!empty($_GET['id'])) {
        $id = $_GET['id'];
        $ress = Ressource::findById(array('id' => $id));
        if(!is_null($ress)) {
            $ress->delete();

            require_once 'vues/VueSuccesSupRessource.php';
            new VueSuccesSupRessource();
        } else {
            require_once 'vues/VueErreurRessourceID.php';
            new VueErreurRessourceID();
        }
    } else {
        require_once 'vues/VueErreurRessourceID.php';
        new VueErreurRessourceID();
    }
}

?>
