<?php

abstract class Vue {
	private $page;

	public function __construct($tpl) {
		$this->page = file_get_contents("templates/$tpl.tpl");
	}

	public function token_remplacer($valeurs) {
		foreach($valeurs AS $token => $valeur)
			$this->page = str_replace('<TPL:'.strtoupper($token).'>', $valeur, $this->page);
	}

	public function token_determiner($token, $afficher = true) {
		$this->page = preg_replace('/<TPL:'.strtoupper($token).':BEGIN>(.*)<TPL:'.strtoupper($token).':END>/s', $afficher ? "\1" : "", $this->page);
	}

	public function token_attraperBloc($token) {
		preg_match('/<TPL:'.strtoupper($token).':BEGIN>(.*)<TPL:'.strtoupper($token).':END>/s', $this->page, $valeur);

		return $valeur[0];
	}

	public function token_remplacerBloc($token, $valeur) {
		$this->page = preg_replace('/<TPL:'.strtoupper($token).':BEGIN>(.*)<TPL:'.strtoupper($token).':END>/s', $valeur, $this->page, 1);
	}

	public abstract function finaliserPage();

	public function ecrire() {
		$page = $this->page;
		$this->page = file_get_contents('templates/base.tpl');

		$this->token_remplacer(array('page' => $page));

		$this->setMenu();
		$this->finaliserPage();

		exit($this->page);
	}

	public function setMenu() {
		@session_start();

		if(empty($_SESSION['login'])) {
			$menu = '<li><a href="compte.php?action=connexion">Connexion</a></li>';
			$menu .= '<li><a href="compte.php?action=creer">Créer un utilisateur</a></li>';

		} else {
			$menu = '<li id="login_compte"><a href="compte.php?action=modifier" title="Modifier votre compte">' . $_SESSION['login'] . '</a></li>';
			$menu .= '<li><a href="compte.php?action=deconnexion">Déconnexion</a></li>';

			if(preg_match('/agenda\.php$/', $_SERVER['SCRIPT_NAME'])) {
				$menu .= '<li><a href="agenda.php?action=creer">Nouvel agenda</a></li>';
				$menu .= '<li><a href="ressource.php?action=creer">Nouvelle ressource</a></li>';

				if(!empty($_GET['action']) && $_GET['action'] == 'consulter') {
					$menu .= '<li><a href="agenda.php?action=partager&amp;id='.intval($_GET['id']).'">Partager</a></li>';
					$menu .= '<li><a href="agenda.php?action=modifier&amp;id='.intval($_GET['id']).'">Modifier</a></li>';
					$menu .= '<li><a href="agenda.php?action=supprimer&amp;id='.intval($_GET['id']).'" onclick="return confirm(\'Supprimer ?\')">Supprimer</a></li>';
					$menu .= '<li><a href="evenement.php?action=creer&amp;id_agenda='.intval($_GET['id']).'">Nouvel événement</a></li>';
				}
			}

			if(preg_match('/evenement\.php$/', $_SERVER['SCRIPT_NAME'])) {
				if(!empty($_GET['action']) && $_GET['action'] == 'consulter') {
					$menu .= '<li><a href="evenement.php?action=inviter&amp;id='.intval($_GET['id']).'">Inviter</a></li>';
					$menu .= '<li><a href="evenement.php?action=modifier&amp;id='.intval($_GET['id']).'">Modifier</a></li>';
					$menu .= '<li><a href="evenement.php?action=supprimer&amp;id='.intval($_GET['id']).'" onclick="return confirm(\'Supprimer ?\')">Supprimer</a></li>';
				}
				if(!empty($_GET['action']) && $_GET['action'] == 'modifier') {
                    $menu .= '<li><a href="ressource.php?action=creer">Nouvelle ressource</a></li>';
                }
				
			}
            if(preg_match('/ressource\.php$/', $_SERVER['SCRIPT_NAME'])) {
				$menu .= '<li><a href="ressource.php?action=creer">Nouvelle ressource</a></li>';

				if(!empty($_GET['action']) && $_GET['action'] == 'consulter') {
					$menu .= '<li><a href="ressource.php?action=modifier&amp;id='.intval($_GET['id']).'">Modifier</a></li>';
					$menu .= '<li><a href="ressource.php?action=supprimer&amp;id='.intval($_GET['id']).'" onclick="return confirm(\'Supprimer ?\')">Supprimer</a></li>';
                }
            }

		}

		$this->token_remplacer(array('menu' => $menu));
	}

	public function __destruct() {
		$this->ecrire();
	}
}

?>
