<?php

require_once 'vues/VueCalendrier.php';

class VueAccueil extends VueCalendrier {
	public function __construct($agendas_proprio, $agendas_partages, $mois = null, $annee = null) {
		parent::__construct('accueil', array_merge($agendas_proprio, $agendas_partages), $mois, $annee);

		$liste_agendas = '';

		foreach($agendas_proprio AS $agenda)
			$liste_agendas .= "<li><a href='agenda.php?action=consulter&amp;id=$agenda->id'>$agenda->nom</a></li>";

		foreach($agendas_partages AS $agenda)
			$liste_agendas .= "<li><strong>Partagé :</strong> <a href='agenda.php?action=consulter&amp;id=$agenda->id'>$agenda->nom</a></li>";

		$this->token_remplacer(array(
			'liste_agendas' => $liste_agendas,
			'mois' => $this->moisFr[$this->mois - 1],
			'annee' => $this->annee,
			'mois_prec' => sprintf(
				'<a href="agenda.php?action=accueil&amp;mois=%d&amp;annee=%d">Mois précédent</a>',
				$this->mois_prec,
				$this->annee_prec),
			'mois_suiv' => sprintf(
				'<a href="agenda.php?action=accueil&amp;mois=%d&amp;annee=%d">Mois suivant</a>',
				$this->mois_suiv,
				$this->annee_suiv),
			'evenements' => $this->evenements
		));
	}

	public function finaliserPage() {
		$this->token_remplacer(array(
			'title' => "Accueil"
		));
	}
}

?>

