<?php

require_once 'vues/Vue.php';

abstract class VueCalendrier extends Vue {
	protected $moisFr = array('Janvier', 'Février', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet', 'Août', 'Septembre', 'Octobre', 'Novembre', 'Décembre');
	protected $mois, $annee, $mois_prec, $mois_suiv, $annee_prec, $annee_suiv, $dernierJour, $premierJour, $evenements;
	
	public function __construct($tpl, $agendas, $mois, $annee) {
		parent::__construct($tpl);

		$this->mois = !empty($mois) ? $mois : date('n');
		$this->annee = !empty($annee) ? $annee : date('Y');

		$this->calculDates();
		$this->evenements = $this->evenements($agendas);
	}

	public function calculDates() {
		if($this->mois - 1 == 0) {
			$this->mois_prec = 12;
			$this->annee_prec = $this->annee - 1;
		} else {
			$this->mois_prec = $this->mois - 1;
			$this->annee_prec = $this->annee;
		}
			
		if($this->mois + 1 == 13) {
			$this->mois_suiv = 1;
			$this->annee_suiv = $this->annee + 1;
		} else {
			$this->mois_suiv = $this->mois + 1;
			$this->annee_suiv = $this->annee;
		}

		$timestamp = mktime(0,0,0, $this->mois, 1, $this->annee);
		$this->dernierJour = date('t', $timestamp);
		$getMois = getdate($timestamp);
		$this->premierJour = $getMois['wday'] - 1;

		if($this->premierJour == -1)
			$this->premierJour = 6;
	}

	function evenements($agendas) {
		$evenements = '';

		for($i = 0; $i < $this->dernierJour + $this->premierJour; $i++) {
			if($i % 7 == 0 )
				$evenements .= "<tr>\n";

			if($i < $this->premierJour)
				$evenements .= "<td></td>\n";
			else {
				$jour = $i - $this->premierJour + 1;
				$jourComplet = sprintf('%4d%02d%02d', $this->annee, $this->mois, $jour);
				$contenu = '';

				@session_start();

				foreach($agendas AS $agenda) {
					if($agenda->afficher) {
						require_once 'classes/Evenement.php';
						$evts = Evenement::findByAgenda($agenda->id);

						foreach($evts AS $evt) {
							if($evt->est_public || (!empty($_SESSION['login']) && $evt->droitsUtilisateur($_SESSION['login']))) {

								$deb = intval(str_replace('-', '', $evt->date_deb));
								$fin = intval(str_replace('-', '', $evt->date_fin));

								if($deb <= $jourComplet && $fin >= $jourComplet) {
									$couleur = sprintf("%06s", trim($agenda->couleur));
									$contenu .= "<br /><a href='evenement.php?action=consulter&amp;id=$evt->id' style='color: #$couleur'>$evt->nom</a>";
								}
							}
						}
					}
				}

				$evenements .= "<td>$jour$contenu</td>\n";
			}

			if($i % 7 == 6)
				$evenements .= "</tr>\n";
		}

		return $evenements;
	}
}

?>

