<?php

require_once 'vues/VueCalendrier.php';

class VueConsulterAgenda extends VueCalendrier {
	public function __construct($agenda, $mois = null, $annee = null) {
		parent::__construct('consulterAgenda', array($agenda), $mois, $annee);

		$this->token_remplacer(array(
			'id' => $agenda->id,
			'nom' => $agenda->nom,
			'desc' => $agenda->descr,
			'mois' => $this->moisFr[$this->mois - 1],
			'annee' => $this->annee,
			'mois_prec' => sprintf(
				'<a href="agenda.php?action=consulter&amp;id=%d&amp;mois=%d&amp;annee=%d">Mois précédent</a>',
				$agenda->id,
				$this->mois_prec,
				$this->annee_prec),
			'mois_suiv' => sprintf(
				'<a href="agenda.php?action=consulter&amp;id=%d&amp;mois=%d&amp;annee=%d">Mois suivant</a>',
				$agenda->id,
				$this->mois_suiv,
				$this->annee_suiv),
			'evenements' => $this->evenements
		));

		$desc = $this->token_attraperBloc('DESC');
		$this->token_remplacerBloc('DESC', empty($agenda->descr) ? '' : $desc);
	}

	public function finaliserPage() {
		$this->token_remplacer(array(
			'title' => "Consulter un agenda"
		));
	}
}

?>

