<?php

require_once 'vues/Vue.php';

class VueConsulterEvenement extends Vue {
	public function __construct($evt, $ressources) {
		parent::__construct('consulterEvenement');

		$dDeb = new DateTime($evt->date_deb);
		$dFin = new DateTime($evt->date_fin);

		$this->token_remplacer(array(
			'id' => $evt->id,
			'recurrence' => $evt->est_recurrent() ? 'Oui' : 'Non',
			'nom' => $evt->nom,
			'desc' => $evt->descr,
			'lieu' => $evt->lieu,
			'date_deb' => $dDeb->format("d/m/Y à H\hi"),
			'date_fin' => $dFin->format("d/m/Y à H\hi"),
			'est_public' => $evt->est_public ? 'Oui' : 'Non',
			'exclusif' => $evt->exclusif ? 'Oui' : 'Non',
            'rappel' => $evt->rappel ? ($evt->rappel / 60).' minutes avant' : 'Aucun',
            'ressources' => $this->listeRessources($ressources)
		));

		$desc = $this->token_attraperBloc('DESC');
		$this->token_remplacerBloc('DESC', is_null($evt->descr) ? '' : $desc);
	}

	public function finaliserPage() {
		$this->token_remplacer(array(
			'title' => "Consulter un événement"
		));
	}

    public function listeRessources($ressources) {
        $html = "";
        foreach($ressources as $res) {
            $html .= "<li><a href=\"ressource.php?action=consulter&amp;id=$res->id\">$res->nom</a></li>";
        }
        return $html;
    }
}

?>
