<?php

require_once 'vues/Vue.php';

class VueFormModifierEvenement extends Vue {

    public function __construct($evt, $ressources) {
	parent::__construct('formEvenement');

	$ressources = $this->selectionRessources($ressources);

	$this->token_remplacer(array(
	    'id' => $evt->id,
	    'verbe' => 'Modifier',
	    'action' => 'modifier',
	    'id_agenda' => '',
	    'nom' => $evt->nom,
	    'desc' => $evt->descr,
	    'lieu' => $evt->lieu,
	    'date_deb' => $evt->date_deb,
	    'date_fin' => $evt->date_fin,
	    'est_public_0' => $evt->est_public ? '' : 'checked="checked"',
	    'est_public_1' => $evt->est_public ? 'checked="checked"' : '',
	    'exclusif_0' => $evt->exclusif ? '' : 'checked="checked"',
	    'exclusif_1' => $evt->exclusif ? 'checked="checked"' : '',
	    'rappel' => $evt->rappel > 0 ? $evt->rappel / 60 : '', 
	    'disable' => (!is_null($evt->id_recurrence) || $evt->est_recurrent()) ? 'readonly="readonly"' : '',
	    'ressources' => $ressources
	));
    }

    public function finaliserPage() {
	$this->token_remplacer(array(
	    'title' => "Modifier un événement"
	));
    }

    public function selectionRessources($ressources) {
	$html = "";
	foreach($ressources as $r) {
	    $html .= '<option value="' . $r->id . '">' . $r->nom . '</option>';
	}

	return $html;
    }

}

?>

